<template>
  <div class="mt-0 d-flex flex-column p-0 bg-transparent">
    <datasets-top-controls :facets="facets" :getPage="getPage" :getLimit="getLimit" class="datasets-top-controls" />
    <div class="container-fluid datasets content" >
      <datasets-title />
      <div class="row">
        <datasets-mobile-dropdown style="border:3px solid red" toggleElementId="#datasetFacets" />
        <datasets-facets v-if="useDatasetFacets"
                         class="col-md-3 col-12 mb-3 mb-md-0 px-0 collapse" id="datasetFacets"
                         :dataScope="dataScope" />
        <datasets-content />
      </div>
      <div class="row">
        <div class="column col-12 col-md-9 offset-md-3">
          <pagination class="mt-3" :items-count="getDatasetsCount" :items-per-page="getLimit" :get-page="getPage"
                      :get-page-count="getPageCount" @setPageLimit="setPageLimit" />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import { debounce, isArray, isNil } from "lodash-es";
import $ from "jquery";
import {
  DatasetsTopControls,
  Pagination,
  fileTypes
} from "@piveau/piveau-hub-ui-modules";
import DatasetsFacets from "./datasetFacets/DatasetsFacets.vue"
import DatasetsTitle from "@/components/search/datasets/DatasetsTitle";
import DatasetsMobileDropdown from "@/components/search/datasets/DatasetsMobileDropdown";
import DatasetsContent from "@/components/search/datasets/DatasetsContent";

export default {
  name: "Datasets",
  components: {
    DatasetsContent,
    DatasetsMobileDropdown,
    DatasetsTitle,
    DatasetsTopControls,
    DatasetsFacets,
    Pagination
  },
  props: {
    infiniteScrolling: {
      type: Boolean,
      default: false,
    }
  },
  metaInfo() {
    return {
      titleTemplate() {
        return this.$t("message.datasets.meta.page.title");
      },
      meta: [
        {
          name: "description",
          vmid: "description",
          content: `${this.$t(
            "message.datasets.meta.description"
          )}`,
        },
        {
          name: "keywords",
          vmid: "keywords",
          content: `${this.$env.keywords} ${this.$t(
            "message.datasets.meta.description"
          )}}`,
        },
        { name: "robots", content: "index, follow" },
      ],
    };
  },
  data() {
    return {
      debouncedOnBottomScroll: debounce(this.onBottomScroll, 500),
      facetFields: [],
      useDatasetFacets: this.$env.content.datasets.facets.useDatasetFacets
    };
  },
  computed: {
    ...mapGetters("datasets", [
      "getDatasetsCount",
      "getFacets",
      "getLimit",
      "getSort",
      "getPage",
      "getPageCount"
    ]),
    showCatalogDetails() {
      return !isNil(this.$route.params.ctlg_id);
    },
    /**
     * @description Returns the current page.
     * @returns {Number}
     *
     * @deprecated use getPage from datasets store instead
     */
    page() {
      return this.$route.query.page;
    },
    /**
     * @description Returns the active facets.
     * @returns {Object}
     */
    facets() {
      const facets = {};
      for (const field of this.facetFields) {
        let urlFacets;
        if (field === 'catalog' && !isNil(this.$route.params.ctlg_id)) urlFacets = this.$route.params.ctlg_id;
        else urlFacets = this.$route.query[field];
        if (!urlFacets) urlFacets = [];
        else if (!Array.isArray(urlFacets)) urlFacets = [urlFacets];
        facets[field] = urlFacets;
      }
      return facets;
    },
    // currentSearchQuery() {
    //   return this.$route.query.query;
    // },
    dataScope() {
      if (!this.$route.query.dataScope) return null;
      if (
        isArray(this.$route.query.dataScope) &&
        this.$route.query.dataScope.length > 0
      )
        return this.$route.query.dataScope[0];
      if (
        isArray(this.$route.query.dataScope) &&
        this.$route.query.dataScope.length === 0
      )
        return null;
      return this.$route.query.dataScope;
    }
  },
  methods: {
    isNil,
    ...mapActions("datasets", [
      "loadDatasets",
      "loadAdditionalDatasets",
      "setPage",
      "addFacet",
      "setFacets",
      "setFacetOperator",
      "setFacetGroupOperator",
      "setDataServices",
      "setPageCount",
      "setLimit",
      "setSort",
      "setDataScope"
    ]),
    isArray,
    /**
     * @description Handler-function for the scroll event.
     */
    onScroll() {
      const items = this.$el.querySelectorAll(".dataset");
      const lastItem = items[items.length - 1];
      if (lastItem) {
        const lastItemPos = lastItem.getBoundingClientRect();
        if (lastItemPos.bottom - window.innerHeight <= 0) {
          this.debouncedOnBottomScroll();
        }
      }
    },
    /**
     * @description Handler-function when bottom of the page is reached.
     */
    onBottomScroll() {
      this.$nextTick(() => {
        this.$Progress.start();
        this.loadAdditionalDatasets()
          .then(() => {
            this.$Progress.finish();
          })
          .catch(() => {
            this.$Progress.fail();
          });
      });
    },
    initLimit() {
      const limit = parseInt(this.$route.query.limit, 10);
      if (limit > 0) this.setLimit(limit);
    },
    initSort() {
      const sort = this.$route.query.sort;
      if (sort) this.setSort(sort);
    },
    setPageLimit(value) {
      this.setLimit(value);
      this.initDatasets();
    },
    initDataScope() {
      this.setDataScope(this.dataScope);
    },
    /**
     * @description Determines the current page.
     */
    initPage() {
      const page = parseInt(this.$route.query.page, 10);
      if (page > 0) this.setPage(page);
      else this.setPage(1);
    },
    /**
     * @descritption Initialize the active facets by checking the route parameters
     */
    initFacets() {
      const fields = this.$env.content.datasets.facets.defaultFacetOrder;
      for (const field of fields) {
        this.facetFields.push(field);
        if (field === 'catalog' && !isNil(this.$route.params.ctlg_id)) {
          this.addFacet({ field, facet: this.$route.params.ctlg_id });
        }
        else if (!Object.prototype.hasOwnProperty.call(this.$route.query, [field])) {
          this.$router
            .replace({
              query: Object.assign({}, this.$route.query, { [field]: [] }),
            })
            .catch((error) => {
              console.error(error);
            });
        } else {
          for (const facet of this.$route.query[field]) {
            // do not add duplicates!
            if (!this.getFacets[field]?.includes(facet)) {

              this.addFacet({ field, facet });
            }
          }
        }
      }
    },
    initFacetOperator() {
      // Always set facet operator to AND when in catalog details mode
      if (this.showCatalogDetails)
        this.setFacetOperator("AND");
      else {
        const op = this.$route.query.facetOperator;
        if (op === "AND" || op === "OR") this.setFacetOperator(op);
      }
    },
    initFacetGroupOperator() {
      // The facetGroupOperator should be the same as the facetOperator
      // Always set facet operator to AND when in catalog details mode
      if (this.showCatalogDetails)
        this.setFacetGroupOperator("AND");
      else {
        const op = this.$route.query.facetOperator;
        if (op === "AND" || op === "OR") this.setFacetGroupOperator(op);
      }
    },
    /**
     * @descritption Initialize the active data services facet by checking the route parameters
     */
    initDataServices() {
      const ds = this.$route.query.dataServices;
      if (ds === "true" || ds === "false") this.setDataServices(ds);
      else {
        this.setDataServices("false");
      }
    },
    initDatasets() {
      this.$nextTick(() => {
        this.$nextTick(() => {
          this.$Progress.start();
          this.loadDatasets({ locale: this.$route.query.locale , fields: this.$route.query.fields })
            .then(() => {
              this.setPageCount(
                Math.ceil(this.getDatasetsCount / this.getLimit)
              );
              this.$Progress.finish();
              $('[data-toggle="tooltip"]').tooltip({
                container: "body",
              });
            })
            .catch(() => this.$Progress.fail())
            .finally(() => this.$root.$emit('contentLoaded'));
        });
      });
    },
    initInfiniteScrolling() {
      if (this.infiniteScrolling)
        window.addEventListener("scroll", this.onScroll);
    },
    getFileTypeColor(format) {
      return fileTypes.getFileTypeColor(format);
    }
  },
  watch: {
    /**
     * @description Watcher for active facets
     */
    // eslint-disable-next-line object-shorthand
    facets: {
      handler(facets) {
        this.setFacets(facets);
      },
      deep: true,
    },
    // eslint-disable-next-line object-shorthand
    page(pageStr) {
      const page = parseInt(pageStr, 10);
      if (page > 0) this.setPage(page);
      else this.setPage(1);
    },
    dataScope: {
      handler() {
        this.initDataScope();
      },
      deep: true,
    },
  },
  created() {
    this.initDataScope();
    this.initLimit();
    this.initPage();
    this.initSort();
    this.initFacetOperator();
    this.initFacetGroupOperator();
    this.initDataServices();
    this.initFacets();
    this.initDatasets();
    this.initInfiniteScrolling();
    setTimeout(() => {
      $(".facets-show-more").each(function () {
        $(this).click(function () {
          $('body').tooltip({ selector: '[data-toggle="tooltip"]' });
        });
      });
    }, 1500);
  },
  mounted() {
    // This is supposed to fix the browser issue (https://gitlab.fokus.fraunhofer.de/piveau/organisation/piveau-scrum-board/-/issues/2344)
    if (this.$route.query.refresh === "true") {
      this.$nextTick(() => {
        this.$nextTick(() => {
          this.loadDatasets({ locale: this.$route.query.locale })
            .then(() => {
              this.$router.push({
                query: { locale: this.$route.query.locale },
              });
            })
            .catch(() => {
              this.$Progress.fail();
            });
        });
      });
    }
  },
  beforeDestroy() {
    $(".tooltip").remove();
    if (this.infiniteScrolling)
      window.removeEventListener("scroll", this.onScroll);
  },
};
</script>

<style lang="scss" scoped>


.dataset-info-box:hover {
  box-shadow: none !important;
  cursor: pointer;
}

#erdpInfobox {
  display: flex;
  padding: 1.25rem;
  .infoIcon {
    height: 20%;
    width: 60%;
    fill: #175baf;
  }
  border:2px solid #175baf;
}

.ecl-message.ecl-message--info {
  //border-left: 4px solid #0xe47cb !important;
  border-radius: 4px 0 0 4px;
  border: none;
  background-color: #f3f6fc;
}

.alert-primary {
  color: #042648;
  background-color: #cddbe8;
  border-color: #baccdf;
}

.content {
  padding: 30px 30px 0 30px;
  margin-top: 15px;
  margin-bottom: 15px;
  background-color: white;
}

.router-link-active {
  color: #175baf !important;
  border: none !important;
  border-bottom: 2px solid #175baf !important;
}

.router-link-inactive {
  color: rgba(0, 0, 0, 0.7);
  border: none !important;

  &:hover {
    color: #175baf;
  }
}

.material-icons.small-icon {
  font-size: 20px;
}

@media screen and (min-width: 768px) {
  #erdpInfobox {
    margin-left: 15px;
  }

  #datasetFacets {
    display: block;
  }
}
</style>
